:- use_module(library(lists), [permutation/2]).

% Kif a Muv listabeli mveletekkel az L listban megadott
% szmokbl felptett kifejezs, amelynek rtke Ertek.
levelek_ertek_kif(L, Ertek, Muv, Kif) :-
	permutation(L, PL),
	levelek_muv_kif(PL, Muv, Kif),
	catch(Kif =:= Ertek, _, fail).

% levelek_muv_kif(+L, +Muv, ?Kif): A Muv listabeli mveletekkel felptett Kif
% kifejezs leveleiben lev szmok listja L.
levelek_muv_kif(L, _Muv, Kif) :-
	L = [Kif], number(Kif).
levelek_muv_kif(L, Muv, Kif) :-
	append(L1, L2, L),
	L1 \= [], L2 \= [], 
	levelek_muv_kif(L1, Muv, K1),
	levelek_muv_kif(L2, Muv, K2),
	member(M, Muv),
	Kif =.. [M,K1,K2].

